<?php
/////////////////////////////////////////////////////////////////////////////////////////////////////////
// Copyright 2010-2011 Softnik Technologies
// Version 0.1.11 2011-01-15
/////////////////////////////////////////////////////////////////////////////////////////////////////////

$db_config_domain_table        	= $db_table_prefix . 'domains';
$db_config_category_table      	= $db_table_prefix . 'catlist';
$db_config_autoquery_table      = $db_table_prefix . 'queries';
$db_config_subdomain_table      = $db_table_prefix . 'subdomains';

$db_config_catconnection_table 	= $db_table_prefix . 'catconn';
$db_config_lookup_queue_table 	= $db_table_prefix . 'luq';
$db_config_tldlist_table 		= $db_table_prefix . 'tlds';

$db_config_whoisservers_table 	= $db_table_prefix . 'whoisservers';

/////////////////////////////////////////////////////////////////////////////////////////////////////////

define("LOOKUP_DOMAIN_WHOIS", 		"1");
define("LOOKUP_IP_ADDRESS",			"2");
define("LOOKUP_HTTP_HOMEPAGE",		"4");
define("LOOKUP_US_TM",				"8");
define("LOOKUP_ALEXA_DATA",			"16");
define("LOOKUP_GOOGLE_PR",			"32");
define("LOOKUP_GOOGLE_LINKS",		"64");
define("LOOKUP_MX_RECORDS",			"128");
define("LOOKUP_PING_RESPONSE",		"256");
define("LOOKUP_BING_LINKS",			"512");
define("LOOKUP_YAHOO_LINKS",		"1024");
define("LOOKUP_SSL_CERTS",			"2048");
define("LOOKUP_IP_WHOIS",			"4096");

///////////////////////////////////////////////////////////////////////////////////////////////////

define("LUQSTAT_WAITING",		0);
define("LUQSTAT_IN_PROGRESS",	1);
define("LUQSTAT_COMPLETED",		2);
define("LUQSTAT_FAILED",		3);

/////////////////////////////////////////////////////////////////////////////////////////////////////////

$valid_domain_table_array		= array (	$db_config_domain_table, $db_config_category_table, $db_config_autoquery_table, 
											$db_config_catconnection_table, $db_config_lookup_queue_table, $db_config_tldlist_table, 
											$db_config_whoisservers_table, $db_config_subdomain_table 
										);

$domain_table_text_fields 		= array (	'registrar', 'ip', 'registrar', 'ns1', 'ns2', 'ns3', 'ns4', 'status', 
											'registry_whois', 'registrar_whois', 
											'redirect_url', 'home_page_status', 'home_page_title', 'home_page_size',
											'mx1', 'mx2', 'mx3', 'mxip1', 'mxip2', 'mxip3',
											'google_pr',
											'whois_server',
											'ping_time',
											'owner', 'organization', 'address', 'owner_country',
											'admin_email', 'tech_email', 'billing_email',
											'alexa_rank', 'alexa_links', 'google_links', 'yahoo_links',
											'notes_a', 'notes_b', 'notes_c', 'notes_d',
											'ip_whois', 'ip_net_name', 'ip_org_name', 'ip_rtech_name',
											'ip_asnumber', 'ip_asname'
											
										);
$domain_table_date_fields 		= array (	'registry_expiry', 'registrar_expiry', 'created_on', 'last_update');
$domain_table_datetime_fields 	= array (	'lookedup', 'ip_checked_at', 'home_page_checked_at', 'google_pr_checked_at', 
											'ping_checked_at', 'mx_checked_at', 'alexa_checked_at', 
											'google_sitepop_checked_at', 'yahoo_sitepop_checked_at',
											'ip_whois_at'
										);
										
$subdomain_table_text_fields 	= array (	'ip', 'ssl_issued_to', 'ssl_issued_by', 
											'notes_a', 'notes_b', 'notes_c', 'notes_d'
										);
										
$subdomain_table_datetime_fields = array (	'ssl_valid_from', 'ssl_valid_to', 
											'ssl_checked_at', 'ip_checked_at'
										);

/////////////////////////////////////////////////////////////////////////////////////////////////////////

function connect_to_mysql_and_select_db()
{
	global $db_config_host, $db_config_username, $db_config_password, $db_config_database;
	
	$dbLink = mysql_connect($db_config_host, $db_config_username, $db_config_password)
	or die("Connection Error: " . mysql_error());
	mysql_query("SET NAMES 'utf8'");
	mysql_select_db($db_config_database) or die("Error conecting to db.");
}

/////////////////////////////////////////////////////////////////////////////////////////////////////////

function get_last_lookup_time_field($lookup_type)
{
	switch($lookup_type)
	{
		case LOOKUP_DOMAIN_WHOIS:
			return "lookedup";
		case LOOKUP_IP_ADDRESS:
			return "ip_checked_at";
		case LOOKUP_HTTP_HOMEPAGE:
			return "home_page_checked_at";
		case LOOKUP_GOOGLE_PR:
			return "google_pr_checked_at";
		case LOOKUP_PING_RESPONSE:
			return 'ping_checked_at';
		case LOOKUP_MX_RECORDS:
			return 'mx_checked_at';
		case LOOKUP_YAHOO_LINKS:
			return 'yahoo_sitepop_checked_at';
		case LOOKUP_GOOGLE_LINKS:
			return 'google_sitepop_checked_at';
		case LOOKUP_ALEXA_DATA:
			return 'alexa_checked_at';
		case LOOKUP_SSL_CERTS:
			return 'ssl_checked_at';
		case LOOKUP_IP_WHOIS:
			return 'ip_whois_at';
		default:
			return "";
	}
}

///////////////////////////////////////////////////////////////////////////////////////////////////
// Add Lookup
// See if a lookup is required.
// See if the lookup entry already exists.
// If No, add


function add_to_lookup_queue($sid, $lookup_type, $min_gap=1440)
{
	global $db_config_lookup_queue_table, $db_config_domain_table, $db_config_subdomain_table;
	$last_lookup_time_field = get_last_lookup_time_field($lookup_type);
	if($last_lookup_time_field != "")
	{
		if($last_lookup_time_field == "ssl_checked_at")
			$sql = "select sid," . $last_lookup_time_field . " from " . $db_config_subdomain_table . " where sid = $sid";
		else
			$sql = "select sid," . $last_lookup_time_field . " from " . $db_config_domain_table . " where sid = $sid";
		$result = mysql_query( $sql ) or die("Couldn't execute your query.".mysql_error());
		$row = mysql_fetch_array($result, MYSQL_ASSOC);
		if($row['sid'] > 0)
		{
			$lookup_required = true;
			$next_lookup = $row[$last_lookup_time_field];
			if($next_lookup != NULL)
			{
				$next_lookup = strtotime($next_lookup) + $min_gap*60; 
				$current_time = time();
				if($next_lookup > $current_time)
					$lookup_required = false;
			}
			
			if($lookup_required)
			{
				$sql = "SELECT COUNT(*) AS count FROM $db_config_lookup_queue_table WHERE sid=$sid AND type='$lookup_type'";  
				$results = mysql_query( $sql ) or die("Couldn't execute your query.".mysql_error() . "<br>" . $sql);
				$existing = mysql_fetch_array($results);  
				if ($existing['count'] == 0) 
				{
					$wait = LUQSTAT_WAITING;
					$sql  = "insert into $db_config_lookup_queue_table (sid, type, status, created_on) values ($sid, $lookup_type, $wait, now());";
					$result = mysql_query($sql) or die("Couldn't execute your query.".mysql_error() . "<br>" . $sql);
					return true;
				}
			}
		}
	}
	return false;
}

/////////////////////////////////////////////////////////////////////////////////////////////////////////

function validate_request_data($field)
{ 
	if(!is_array($field))
		$field = mysql_real_escape_string($field);
    return $field;
}

/////////////////////////////////////////////////////////////////////////////////////////////////////////		
		
function add_quote($string)
{
	$string = validate_request_data($string);
	str_replace("'", "''", $string);
	return "'" . $string . "'";
}

/////////////////////////////////////////////////////////////////////////////////////////////////////////

function fnGetSQLSearchString($searchOperation, $searchString)
{
	switch($searchOperation)
	{
		case 'eq': $searchCondition = '= '    	. add_quote($searchString); 		break;
		case 'ne': $searchCondition = '!= '   	. add_quote($searchString); 		break;
		case 'bw': $searchCondition = 'LIKE ' 	. add_quote($searchString.'%'); 	break;
		case 'ew': $searchCondition = 'LIKE '	. add_quote('%'.$searchString); 	break;
		case 'cn': $searchCondition = 'LIKE '	. add_quote('%'.$searchString.'%'); break;
		case 'lt': $searchCondition = '< '    	. add_quote($searchString); 		break;
		case 'gt': $searchCondition = '> '    	. add_quote($searchString); 		break;
		case 'le': $searchCondition = '<= '   	. add_quote($searchString); 		break;
		case 'ge': $searchCondition = '>= '   	. add_quote($searchString); 		break;
	}
	return $searchCondition;
}

/////////////////////////////////////////////////////////////////////////////////////////////////////////
// @param string $dt            // MySQL formatted date (like 2010-01-01) 
// @param int $year_offset        // like 2 or -2, or 5 or -5 ... 
// @param int $month_offset    // like 2 or -2, or 5 or -5 ... 
// @param in $day_offset        // like 2 or -2, or 5 or -5 ...     
// @return string             // the new MySQL formatted date (like 2009-07-01) 
function MySQLDateOffset($dt,$year_offset='',$month_offset='',$day_offset='') 
{ 
      return ($dt=='0000-00-00') ? '' : 
		date ("Y-m-d", mktime(0,0,0,substr($dt,5,2)+$month_offset,substr($dt,8,2)+ 
		$day_offset,substr($dt,0,4)+$year_offset)); 
} 

/////////////////////////////////////////////////////////////////////////////////////////////////////////

function wrap_quotes($str)
{
	return "'" . $str . "'";
}

/////////////////////////////////////////////////////////////////////////////////////////////////////////

function is_date( $str ) 
{ 
	$stamp = strtotime( $str ); 
	if (!is_numeric($stamp)) 
		return FALSE; 
	$month = date( 'm', $stamp ); 
	$day   = date( 'd', $stamp ); 
	$year  = date( 'Y', $stamp ); 
	if (checkdate($month, $day, $year)) 
		return TRUE; 
	return FALSE; 
} 

/////////////////////////////////////////////////////////////////////////////////////////////////////////
// Look for multiple [TODAY+XX] or [TODAY-XX] and replace it with appropriate date strings (wrapped 
// in single quotes.
function parse_custom_sql_query($query)
{
	$pos = stripos($query, "[TODAY");
	while($pos !== false)
	{
		$qleft  = trim(substr($query, 0, $pos));
		$qright = trim(substr($query, $pos+6, strlen($query)-$pos-6));
		$epos   = stripos($qright, "]");
		
		if($epos !== false)
		{
			$qdays  = trim(substr($qright, 0, $epos));
			$qright = trim(substr($qright, $epos+1, strlen($qright)-$epos-1));
			
			$sign = substr($qdays, 0, 1);
			$days = trim(substr($qdays, 1, strlen($qdays)-1));
			$days = $sign == "-" ? (-$days) : $days;
			$qdate = wrap_quotes(MySQLDateOffset(date("Y-m-d"),0,0,$days));
			
			$query = $qleft . " " . $qdate . " " . $qright;
		}
		else
			break;
			
		$pos = stripos($query, "[TODAY");
	}
	return $query;
}

/////////////////////////////////////////////////////////////////////////////////////////////////////////

function get_query_from_aqid($aqid)
{
	global $db_config_autoquery_table, $db_config_domain_table, $db_config_catconnection_table;
	$query = "";
	$sql = "select query from " . $db_config_autoquery_table . " where id = " . $aqid;
	$idresults = mysql_query($sql) or die ("Error reading from database");  
	$row = mysql_fetch_array($idresults, MYSQL_ASSOC);
	if(count($row) == 1 && isset($row['query']))
	{
		$query = $row['query'];
		$query = str_replace("[domains]", $db_config_domain_table, $query);
		$query = str_replace("[catconn]", $db_config_catconnection_table, $query);
		$query = str_replace("[TODAY]", wrap_quotes(date("Y-m-d")), $query);
		$query = parse_custom_sql_query($query);
	}
	return $query;
}

/////////////////////////////////////////////////////////////////////////////////////////////////////////

function get_whois_server_from_tld($tld)
{
	global $db_config_tldlist_table;
	$sql = "select server from " . $db_config_tldlist_table . " where tld = '$tld'";
	$idresults = mysql_query($sql) or die ("Error reading from database");  
	$row = mysql_fetch_array($idresults, MYSQL_ASSOC);
	if(count($row) == 1 && isset($row['server']))
		return $row['server'];
	return "";
}

/////////////////////////////////////////////////////////////////////////////////////////////////////////

function get_raw_whois_query_from_whoisserver($server)
{
	global $db_config_whoisservers_table;
	
	$query = "";
	$sql = "select query from " . $db_config_whoisservers_table . " where server = '" . $server . "'";
	$idresults = mysql_query($sql) or die ("Error reading from database" . mysql_error());  
	$row = mysql_fetch_array($idresults, MYSQL_ASSOC);
	if(count($row) == 1 && isset($row['query']))
	{
		$query = trim($row['query']);
	}
	return $query;
}

/////////////////////////////////////////////////////////////////////////////////////////////////////////

function get_whois_query_from_whoisserver($domain, $server)
{
	global $db_config_whoisservers_table;
	
	$query = $domain;
	$sql = "select query from " . $db_config_whoisservers_table . " where server = '" . $server . "'";
	$idresults = mysql_query($sql) or die ("Error reading from database" . mysql_error());  
	$row = mysql_fetch_array($idresults, MYSQL_ASSOC);
	if(count($row) == 1 && isset($row['query']))
	{
		$query = trim($row['query']);
		if($query != "")
		{
			if(strstr($query, "{d}"))
				$query = str_replace("{d}", $domain, $query);
			else
				$query .= " " . $domain;
		}
	}
	return $query;
}

/////////////////////////////////////////////////////////////////////////////////////////////////////////

function get_whois_port_from_whoisserver($server)
{
	global $db_config_whoisservers_table;
	
	$port = 0;
	$sql = "select port from " . $db_config_whoisservers_table . " where server = '" . $server . "'";
	$idresults = mysql_query($sql) or die ("Error reading from database" . mysql_error());  
	$row = mysql_fetch_array($idresults, MYSQL_ASSOC);
	if(count($row) == 1 && isset($row['port']))
	{
		$port = $row['port'];
	}
	return $port > 0 ? $port : 43;
}

/////////////////////////////////////////////////////////////////////////////////////////////////////////

function get_max_connections_from_whoisserver($server)
{
	global $db_config_whoisservers_table;
	
	$maxconnections = 0;
	$sql = "select maxconnections from " . $db_config_whoisservers_table . " where server = '" . $server . "'";
	$idresults = mysql_query($sql) or die ("Error reading from database" . mysql_error());  
	$row = mysql_fetch_array($idresults, MYSQL_ASSOC);
	if(count($row) == 1 && isset($row['maxconnections']))
	{
		$maxconnections = $row['maxconnections'];
	}
	return $maxconnections >= 1 ? $maxconnections : 1;
}

/////////////////////////////////////////////////////////////////////////////////////////////////////////

function get_connection_interval_from_whoisserver($server)
{
	global $db_config_whoisservers_table;
	
	$conninterval = 0;
	$sql = "select conninterval from " . $db_config_whoisservers_table . " where server = '" . $server . "'";
	$idresults = mysql_query($sql) or die ("Error reading from database" . mysql_error());  
	$row = mysql_fetch_array($idresults, MYSQL_ASSOC);
	if(count($row) == 1 && isset($row['conninterval']))
	{
		$conninterval = $row['conninterval'];
	}
	return $conninterval >= 1 ? $conninterval : 10;
}

/////////////////////////////////////////////////////////////////////////////////////////////////////////

function get_dateformat_from_whoisserver($server)
{
	global $db_config_whoisservers_table;
	
	$format = "";
	$sql = "select dateformat from " . $db_config_whoisservers_table . " where server = '" . $server . "'";
	$idresults = mysql_query($sql) or die ("Error reading from database" . mysql_error());  
	$row = mysql_fetch_array($idresults, MYSQL_ASSOC);
	if(count($row) == 1 && isset($row['dateformat']))
	{
		$format = $row['dateformat'];
	}
	return $format;
}

/////////////////////////////////////////////////////////////////////////////////////////////////////////

function get_searchtoken_from_whoisserver($server)
{
	global $db_config_whoisservers_table;
	
	$format = "";
	$sql = "select searchtoken from " . $db_config_whoisservers_table . " where server = '" . $server . "'";
	$idresults = mysql_query($sql) or die ("Error reading from database" . mysql_error());  
	$row = mysql_fetch_array($idresults, MYSQL_ASSOC);
	if(count($row) == 1 && isset($row['searchtoken']))
	{
		$format = $row['searchtoken'];
	}
	return $format;
}

/////////////////////////////////////////////////////////////////////////////////////////////////////////

function set_dateformat_for_whoisserver($server, $format)
{
	global $db_config_whoisservers_table;
	
	$sqlCount = "SELECT COUNT(*) AS count FROM $db_config_whoisservers_table WHERE server='$server'";  
	$results = mysql_query($sqlCount) or die("Couldn't execute query.".mysql_error());
	$existing = mysql_fetch_array($results);  
	if ($existing['count'] == 0) 
	{
		$sqlAdd  = "insert into $db_config_whoisservers_table (server, searchtoken, dateformat) values ('$server', '', '$format');";
		$result = mysql_query($sqlAdd) or die("Couldn't execute your query.".mysql_error() . "<br>" . $sqlAdd);
		return true;
	}
	else if($existing['count'] == 1)
	{
		$sqlAdd = "update $db_config_whoisservers_table set dateformat='$format' where server='$server'";
		$result = mysql_query( $sqlAdd ) or die("Couldn't execute query.".mysql_error());
		return true;
	}
	return false;
}

/////////////////////////////////////////////////////////////////////////////////////////////////////////

function get_raw_translate_data_from_whoisserver($server)
{
	global $db_config_whoisservers_table;
	
	$xlate = "";
	$sql = "select xlate from " . $db_config_whoisservers_table . " where server = '" . $server . "'";
	$idresults = mysql_query($sql) or die ("Error reading from database" . mysql_error());  
	$row = mysql_fetch_array($idresults, MYSQL_ASSOC);
	if(count($row) == 1 && isset($row['xlate']))
	{
		$xlate = trim($row['xlate']);
	}
	return $xlate;
}

/////////////////////////////////////////////////////////////////////////////////////////////////////////

function get_translate_array_from_whoisserver($server, &$darray)
{
	global $db_config_whoisservers_table;
	
	$rawdata = "";
	$sql = "select xlate from " . $db_config_whoisservers_table . " where server = '" . $server . "'";
	$idresults = mysql_query($sql) or die ("Error reading from database" . mysql_error());  
	$row = mysql_fetch_array($idresults, MYSQL_ASSOC);
	if(count($row) == 1 && isset($row['xlate']))
		$rawdata = trim($row['xlate']);
		
	if($rawdata != "")
	{
		$entries = explode("\n", $rawdata);
		foreach($entries as $k => $v)
		{
			$kvpair = explode("=>", $v);
			if(count($kvpair) == 2)
			$kv = trim($kvpair[0]);
			$vv = trim($kvpair[1]);
			$kv = trim($kv, "'");
			$vv = trim($vv, "'");
			if($kv != "" && $vv != "")
				$darray[$kv] = $vv;
		}
	}
	return count($darray) > 0 ? true : false;
}

/////////////////////////////////////////////////////////////////////////////////////////////////////////

function get_subdomain_name_from_id($id)
{
	global $db_config_subdomain_table;
	$subdomain = "";
	$sql = "select subdomain from " . $db_config_subdomain_table . " where hid = " . $id;
	$idresults = mysql_query($sql) or die ("Error reading from database");  
	$row = mysql_fetch_array($idresults, MYSQL_ASSOC);
	if(count($row) == 1 && isset($row['subdomain']))
		$subdomain = $row['subdomain'];
	return $subdomain;
}

/////////////////////////////////////////////////////////////////////////////////////////////////////////

function get_domain_name_from_sid($sid)
{
	global $db_config_domain_table;
	$domain = "";
	$sql = "select domain from " . $db_config_domain_table . " where sid = " . $sid;
	$idresults = mysql_query($sql) or die ("Error reading from database");  
	$row = mysql_fetch_array($idresults, MYSQL_ASSOC);
	if(count($row) == 1 && isset($row['domain']))
		$domain = $row['domain'];
	return $domain;
}

/////////////////////////////////////////////////////////////////////////////////////////////////////////

function get_sid_from_domain_name($domain)
{
	global $db_config_domain_table;
	$sql = "select sid from " . $db_config_domain_table . " where domain = '$domain'";
	$idresults = mysql_query($sql) or die ("Error reading from database");  
	$row = mysql_fetch_array($idresults, MYSQL_ASSOC);
	if(count($row) == 1 && isset($row['sid']))
		return $row['sid'];
	return 0;
}

/////////////////////////////////////////////////////////////////////////////////////////////////////////

function get_ip_from_domain_name($domain)
{
	global $db_config_domain_table;
	$sql = "select ip from " . $db_config_domain_table . " where domain = '$domain'";
	$idresults = mysql_query($sql) or die ("Error reading from database");  
	$row = mysql_fetch_array($idresults, MYSQL_ASSOC);
	if(count($row) == 1 && isset($row['ip']))
		return $row['ip'];
	return "";
}

/////////////////////////////////////////////////////////////////////////////////////////////////////////

function get_registrar_whois_server_from_domain_name($domain)
{
	global $db_config_domain_table;
	$sql = "select whois_server from " . $db_config_domain_table . " where domain = '$domain'";
	$idresults = mysql_query($sql) or die ("Error reading from database");  
	$row = mysql_fetch_array($idresults, MYSQL_ASSOC);
	if(count($row) == 1 && isset($row['whois_server']))
		return $row['whois_server'];
	return "";
}

/////////////////////////////////////////////////////////////////////////////////////////////////////////

function get_hid_from_subdomain($subdomain)
{
	global $db_config_subdomain_table;
	$sql = "select sid from " . $db_config_subdomain_table . " where subdomain = '$subdomain'";
	$idresults = mysql_query($sql) or die ("Error reading from database");  
	$row = mysql_fetch_array($idresults, MYSQL_ASSOC);
	if(count($row) == 1 && isset($row['hid']))
		return $row['hid'];
	return 0;
}

/////////////////////////////////////////////////////////////////////////////////////////////////////////

function rename_category($CategoryID, $CategoryName)
{
	global $db_config_category_table;
	
	$sqlCount = "SELECT COUNT(*) AS count FROM $db_config_category_table WHERE CategoryName='$CategoryName'";  
	$results = mysql_query($sqlCount) or die("Couldn't execute query.".mysql_error());
	$existing = mysql_fetch_array($results);  
	if ($existing['count'] == 0) 
	{
		$sqlAdd = "update $db_config_category_table set CategoryName='$CategoryName' where CategoryID=$CategoryID";
		$result = mysql_query( $sqlAdd ) or die("Couldn't execute query.".mysql_error());
		return true;
	}
	return false;
}

/////////////////////////////////////////////////////////////////////////////////////////////////////////

function update_domain_table($darray, $domain, $manualedit=0)
{
	global $db_config_domain_table, $domain_table_text_fields, $domain_table_datetime_fields, $domain_table_date_fields;
	
	$sql = 'update ' . $db_config_domain_table . ' set ';
		
	$updateArray = array();
	
	foreach($darray as $key=>$uvalue) 
	{
		$value = trim(validate_request_data($uvalue));
		$value = trim($value,chr(0xC2).chr(0xA0)); 
		
		if($key == 'id' || $key == 'domain')
			continue;
		else if(in_array($key, $domain_table_text_fields))
		{
			if($key == 'address')
				$value = utf8_encode($value);
			$updateArray[$key] = $key . '=' . "'" . $value . "'"; 
		}
		else if(in_array($key, $domain_table_date_fields))
		{
			if(strlen($value) < 6)
				$updateArray[$key] = $key . "=NULL"; 
			else if(is_date($value) === true)
			{
				$dateval = strtotime($value);
				$updateArray[$key] = $key . '=' . "'" . date("Y-m-d", $dateval) . "'"; 
			}
		}
		else if(in_array($key, $domain_table_datetime_fields))
		{
			if(strlen($value) < 12)
				$updateArray[$key] = $key . "=NULL"; 
			else if(is_date($value) === true)
			{
				$dateval = strtotime($value);
				$updateArray[$key] = $key . '=' . "'" . date("Y-m-d H:i:s", $dateval) . "'"; 
			}
		}
	}
	$sql .= implode(',',$updateArray);
	if($manualedit)
		$sql .= ',edited=1,manual_edited_at=NOW()';
	$sql .= " where domain = '" . $domain . "'";
	
	if(count($updateArray) || $manualedit)
	{
		$result = mysql_query( $sql );
		if(!$result)
		{
			//$msg = "Couldn't execute your query. " . mysql_error() . "\n";
			//logToFile("php.log", $msg);
		}
	}
}

/////////////////////////////////////////////////////////////////////////////////////////////////////////

function update_subdomain_table($darray, $host, $domain, $manualedit=0)
{
	global $db_config_domain_table, $domain_table_text_fields, $domain_table_datetime_fields, $domain_table_date_fields, $db_config_subdomain_table;
	global $subdomain_table_text_fields, $subdomain_table_datetime_fields;
	
	$did = get_sid_from_domain_name($domain);
	
	$sql = 'update ' . $db_config_subdomain_table . ' set ';
		
	$updateArray = array();
	
	foreach($darray as $key=>$uvalue) 
	{
		$value = trim(validate_request_data($uvalue));
		$value = trim($value,chr(0xC2).chr(0xA0)); 
		
		if($key == 'id' || $key == 'domain' || $key == 'subdomain' || $key == 'hid' || $key == 'sid')
			continue;
		else if(in_array($key, $subdomain_table_text_fields))
		{
			$updateArray[$key] = $key . '=' . "'" . $value . "'"; 
		}
		else if(in_array($key, $subdomain_table_datetime_fields))
		{
			if(strlen($value) < 12)
				$updateArray[$key] = $key . "=NULL"; 
			else if(is_date($value) === true)
			{
				$dateval = strtotime($value);
				$updateArray[$key] = $key . '=' . "'" . date("Y-m-d H:i:s", $dateval) . "'"; 
			}
		}
	}
	$sql .= implode(',',$updateArray);
	if($manualedit)
		$sql .= ',edited=1,manual_edited_at=NOW()';
	$sql .= " where subdomain = '" . $host . "' AND sid = " . $did;
	
	if(count($updateArray) || $manualedit)
	{
		$result = mysql_query( $sql );
		if(!$result)
		{
			//$msg = "Couldn't execute your query. " . mysql_error() . "\n";
			//logToFile("php.log", $msg);
		}
	}
}

//////////////////////////////////////////////////////////////////////

function check_ioncube_loader()
{
	if ( extension_loaded('ionCube Loader') ) 
	{
		return "Installed";
	}
	else
		return "Error";
}

/////////////////////////////////////////////////////////////////////////////////////////////////////////

function get_base_path()
{
	$basepath = $_SERVER['PHP_SELF'];
	$pieces = explode("/", $basepath);
	if(count($pieces) > 1)
		unset($pieces[count($pieces)-1]);
	$basepath = implode("/", $pieces);
	$basepath = str_ireplace("/lib/php", "", $basepath);
	return $basepath . "/";
}

//////////////////////////////////////////////////////////////////////

function debug_out_domain_data($dataarray)
{
	global $domain_table_text_fields, $domain_table_datetime_fields, $domain_table_date_fields;
	echo "<pre>";
	foreach($dataarray as $key=>$val)
	{
		if(in_array($key, $domain_table_text_fields) || in_array($key, $domain_table_date_fields) || in_array($key, $domain_table_datetime_fields))
		{
			if($key != "registrar_whois" && $key != "registry_whois" && $key != "ip_whois")
				echo "[" . $key . "] => " . $val . "\r\n";
		}
	}
	if(isset($dataarray["registry_whois"]))
	{
		echo "<pre>\r\n\r\n";
		echo $dataarray["registry_whois"];
		echo "\r\n\r\n</pre>";
	}
	if(isset($dataarray["registrar_whois"]))
	{
		echo "<pre>\r\n\r\n";
		echo $dataarray["registrar_whois"];
		echo "\r\n\r\n</pre>";
	}
	if(isset($dataarray["ip_whois"]))
	{
		echo "<pre>\r\n\r\n";
		echo $dataarray["ip_whois"];
		echo "\r\n\r\n</pre>";
	}
}

//////////////////////////////////////////////////////////////////////

function hex2bin($data) 
{ 
    $len = strlen($data); 
    return pack("H" . $len, $data); 
} 

/////////////////////////////////////////////////////////////////////////////////////////////////////////

function logToFile($filename, $msg)
{ 
	$fd = fopen($filename, "a");
	fwrite($fd, $msg);
	fclose($fd);
}

/////////////////////////////////////////////////////////////////////////////////////////////////////////

function logRequestData()
{
	$timestamp = strftime("%c",time());
	$ldata = "\n--" . $timestamp . "--\n";
	foreach ($_REQUEST as $key=>$value) 
	{
		$ldata .= $key . " - " . $value . "\n";
	}
	logToFile("php.log", $ldata);
}

/////////////////////////////////////////////////////////////////////////////////////////////////////////

function get_string_between($string, $start, $end, $includetokens=false)
{
    $string = " ".$string;
    $ini = strpos($string,$start);
    if ($ini == 0) return "";
	if(!$includetokens)
		$ini += strlen($start);
    $len = strpos($string,$end,$ini) - $ini;
	if($includetokens)
		$len += strlen($end);
    return substr($string,$ini,$len);
}

/////////////////////////////////////////////////////////////////////////////////////////////////////////

?>
