<?php
/////////////////////////////////////////////////////////////////////////////////////////////////////////
// Copyright 2010-2011 Softnik Technologies
// Version 0.1.11 2011-01-15
/////////////////////////////////////////////////////////////////////////////////////////////////////////

/////////////////////////////////////////////////////////////////////////////////////////////////////////
require_once('whois/include.php');
/////////////////////////////////////////////////////////////////////////////////////////////////////////

function get_domainparts_from_url($url, &$tld, &$domain, &$subdomain, &$wserver)
{
	global $db_config_tldlist_table;
	
	$domain = $url;

	$url = idn_convert($domain);
	
	$parts = parse_url($url);
	if($parts !== false)
	{
		if(isset($parts['host']))
		{
			$domain = $parts['host'];
			$domain = idn_reconvert($domain);
		}
	}
	
	$res = mysql_query("SELECT tld,server FROM " . $db_config_tldlist_table . " ORDER BY LENGTH(tld) DESC") or die('Couldn t execute query.'.mysql_error());
	while ($arr = mysql_fetch_assoc($res)) 
	{
		$lookfor = "." . $arr['tld'];
		$domaintail = mb_substr($domain, -mb_strlen($lookfor));
		if ($domaintail == $lookfor) 
		{ 
			$tld = ltrim($arr['tld'], ".");
			$domainhead = mb_substr($domain, 0, mb_strlen($domain)-strlen($tld)-1); 
			$domain_parts = explode(".", $domainhead);
			$domain = array_pop($domain_parts);
			$subdomain  = implode(".", $domain_parts);
			$wserver = $arr['server'];
			return true;
		}
    }
	return false;
}

/////////////////////////////////////////////////////////////////////////////////////////////////////////

function whois_lookup_domain($domain, $whoisserver)
{
	$domain = idn_convert($domain);

	$query = get_whois_query(mb_strtolower($domain), $whoisserver);
	
	$m_connectiontimeout = 10;
	$m_sockettimeout = 30;

	$whoisserver = strtolower($whoisserver);
	
	$port = get_whois_port_from_whoisserver($whoisserver);
	
	$data = "";
	if($query != '' && $whoisserver != '' ) 
	{
		$fp = @fsockopen($whoisserver, $port, $errno, $errstr, $m_connectiontimeout);
		if( $fp )
		{
			@fputs($fp, $query."\r\n");
			@socket_set_timeout($fp, $m_sockettimeout);
			while( !@feof($fp) )
				$data .= @fread($fp, 4096);
			@fclose($fp);
		}
		else
			$data = "Error - unable to connect to $whoisserver";
	}
	
	return $data;
}

/////////////////////////////////////////////////////////////////////////////////////////////////////////

function do_domain_whois($domain_name, $spit_out=false)
{
	if(get_domainparts_from_url($domain_name, $tld, $domain, $subdomain, $wserver) === true)
	{
		// Make sure that only actual domain is passed.
		// Things like www.domain.com will create problems.
		$fulldomain = $domain_name; //$domain . "." . $tld;
		
		$whois01 = whois_lookup_domain($fulldomain, $wserver);
	
		$data_array01 = array();
		do_whois_postlookup($fulldomain, $wserver, $whois01, $data_array01, $deeplookup, $secserver);
		if(is_array($data_array01))
		{
			update_domain_table($data_array01, $fulldomain);
			if($spit_out)
			{
				//echo "<pre>"; print_r($data_array01); echo "</pre>";
				debug_out_domain_data($data_array01);
			}
		}
		
		if($deeplookup)
		{
			$whois02 = whois_lookup_domain($fulldomain, $secserver);
			$data_array02 = array();
			do_whois_post2ndlookup($fulldomain, $secserver, $whois02, $data_array02, NULL, NULL);
			if(is_array($data_array02))
			{
				update_domain_table($data_array02, $fulldomain);
				if($spit_out)
				{
					//echo "<pre>"; print_r($data_array02); echo "</pre>";
					debug_out_domain_data($data_array02);
				}
			}
		}
	}
}

/////////////////////////////////////////////////////////////////////////////////////////////////////////

function whois_lookup_ip($ip, $whoisserver, $port=43)
{
	$whoisserver = strtolower($whoisserver);
	$query = trim($ip);
	$validip = filter_var($query, FILTER_VALIDATE_IP);
	if($whoisserver == "whois.arin.net" && $validip == $query && $query != "")
		$query = "n " . $query;
	else if($whoisserver == "whois.arin.net" && $query != "")
		$query = "z " . $query;
	
	$m_connectiontimeout = 10;
	$m_sockettimeout = 30;
	
	$data = "";
	if($query != '' && $whoisserver != '' ) 
	{
		$fp = @fsockopen($whoisserver, $port, $errno, $errstr, $m_connectiontimeout);
		if( $fp )
		{
			@fputs($fp, $query."\r\n");
			@socket_set_timeout($fp, $m_sockettimeout);
			while( !@feof($fp) )
				$data .= @fread($fp, 4096);
			@fclose($fp);
		}
		else
			$data = "Error - unable to connect to $whoisserver";
	}
	
	return $data;
}

/////////////////////////////////////////////////////////////////////////////////////////////////////////

function ip_whois($ip)
{
	$whoisserver = "whois.arin.net";
	$data = whois_lookup_ip($ip, $whoisserver);
	if(stristr($data, "ReferralServer:"))
	{
		$port = 43;
		$p1 = Trim(get_string_between($data, "ReferralServer:", "\n"));
		$p1 = str_replace("rwhois://", "", $p1);
		$p1 = str_replace("whois://", "", $p1);
		$s1 = strpos($p1, ":");
		if($s1 !== false)
		{
			$port = substr($p1, $s1+1);
			$p1 = substr($p1, 0, strlen($p1)-strlen($port)-1);
		}
		$whoisserver = $p1;
		$data = whois_lookup_ip($ip, $whoisserver, $port);
	}
	else if(stristr($data, "Allocated to APNIC"))
	{
		$whoisserver = "whois.apnic.net";
		$data = whois_lookup_ip($ip, $whoisserver);
	}
	else if(stristr($data, "Allocated to RIPE"))
	{
		$whoisserver = "whois.ripe.net";
		$data = whois_lookup_ip($ip, $whoisserver);
	}
	else if(stristr($data, "Allocated to AfriNIC"))
	{
		$whoisserver = "whois.afrinic.net";
		$data = whois_lookup_ip($ip, $whoisserver);
	}
	else if(stristr($data, "Allocated to LACNIC"))
	{
		$whoisserver = "whois.lacnic.net";
		$data = whois_lookup_ip($ip, $whoisserver);
	}
	else
	{
		$dcopy = $data;
		$netblocks = array();
		while(1)
		{
			$p1 = Trim(get_string_between($dcopy, "(NET", ")", true));
			if($p1 != "")
			{
				$netblocks[] = substr($p1, 1, strlen($p1)-2);
				$dcopy = str_replace($p1, "", $dcopy);
			}
			else
				break;
		}
		$count = count($netblocks);
		if($count)
		{
			$lookup = $netblocks[$count-1];
			$data = whois_lookup_ip($lookup, $whoisserver);
		}
	}
	$data_array = array();
	generic_ipwhois_parser($whoisserver, $data, $data_array);
	//echo "*<br><pre>"; print_r($data_array); echo "</pre>";
	return $data_array;
}

/////////////////////////////////////////////////////////////////////////////////////////////////////////

function do_ip_whois($domain_name, $spit_out=false)
{
	$ip = get_ip_from_domain_name($domain_name);
	if($ip == "")
	{
		$sid = get_sid_from_domain_name($domain_name);
		if($sid > 0)
		{
			do_ip_lookup($domain_name);
			$ip = get_ip_from_domain_name($domain_name);
		}
	}
	
	if($ip != "" && $ip != "-" && $ip != "error")
	{
		$data_array = ip_whois($ip);
		if($spit_out)
		{
			debug_out_domain_data($data_array);
		}
		update_domain_table($data_array, $domain_name);
	}
	else 
	{
		if($spit_out)
			echo $ip . " " . $domain_name . "<br>";
	}
}

/////////////////////////////////////////////////////////////////////////////////////////////////////////


?>
